#include "piodio.h"

extern char device_module[LINE_SIZE + 1];

WORD PIODX6_PORT_ID[12] = {
                              IXPIO_P0, IXPIO_P1, IXPIO_P2,
                              IXPIO_P3, IXPIO_P4, IXPIO_P5,
                              IXPIO_P6, IXPIO_P7, IXPIO_P8,
                              IXPIO_P9, IXPIO_P10, IXPIO_P11
                          };

/* PIO-DA16 output data */
WORD PIODA16_Digital_Output(WORD fd, WORD data)
{
  ixpio_digital_t dout;
  dout.data.u16 = data;

  if (ioctl(fd, IXPIO_DIGITAL_OUT, &dout))
  {
    close(fd);
    return PIODA_DIGITAL_OUTPUT_ERROR;
  }

  return SUCCESS;
}

/* PIO-DA16 input data */
WORD PIODA16_Digital_Input(WORD fd, WORD *di_data)
{
  ixpio_digital_t din;

  din.data.u16 = 0;

  if (ioctl(fd, IXPIO_DIGITAL_IN, &din))
  {
    close(fd);
    return PIODA_DIGITAL_INPUT_ERROR;
  }

  *di_data = din.data.u16;

  return SUCCESS;
}

WORD PIODA16_Int_Source_Init(WORD fd, WORD signal, WORD int_source)
{
  ixpio_reg_t reg;
  struct sigaction act_old;

  if (int_source != PIODA16_INT0 && int_source != PIODA16_INT1 && int_source != PIODA16_ALL_INT)
  {
    close(fd);
    sigaction(signal, &act_old, NULL);
    return PIODA_INT_SOURCE_DEFINED_ERROR;
  }

  /* configure board interrupt */
  reg.id = IXPIO_IMCR;
  reg.value = int_source;

  if (PIODA_OutputByte(fd, &reg))
  {
    sigaction(signal, &act_old, NULL);
    return PIODA_CONFIGURE_INTERRUPT_ERROR;
  }

  return SUCCESS;
}

